#!/usr/local/bin/python3

import re,sys
from collections import OrderedDict

def change_MIDORI_nameLine(nameline_fn):
    #print("### change_MIDORI_nameLine() ###<br>")
    #print("nameline_fn", nameline_fn, "<br>")  
    # nameline_fn >SRRNA.AB102724.1.42592 AB102724.1.70.1031 root_1;norank_cellular_organisms_131567;superkingdom_Eukaryota_2759;clade_Opisthokonta_33154;kingdom_Metazoa_33208;clade_Eumetazoa_6072;clade_Bilateria_33213;clade_Deuterostomia_33511;phylum_Chordata_7711;subphylum_Craniata_89593;clade_Vertebrata_7742;clade_Gnathostomata_7776;clade_Teleostomi_117570;clade_Euteleostomi_117571;superclass_Actinopterygii_7898;class_Actinopteri_186623;subclass_Neopterygii_41665;infraclass_Teleostei_32443;clade_Osteoglossocephalai_1489341;norank_Clupeocephala_186625;cohort_Euteleosteomorpha_1489388;clade_Neoteleostei_123365;clade_Eurypterygia_123366;clade_Ctenosquamata_123367;clade_Acanthomorphata_123368;clade_Euacanthomorphacea_123369;clade_Percomorphaceae_1489872;clade_Pelagiaria_1489885;order_Scombriformes_1489894;family_Scombridae_8224;subfamily_Scombrinae_186745;tribe_Scombrini_186746;genus_Scomber_13675;species_Scomber japonicus_13676
    # >KT619054.1.7982.8149 root_1;norank_cellular_organisms_131567;superkingdom_Eukaryota_2759;norank_Opisthokonta_33154;kingdom_Metazoa_33208;norank_Eumetazoa_6072;norank_Bilateria_33213;norank_Deuterostomia_33511;phylum_Chordata_7711;subphylum_Craniata_89593;norank_Vertebrata_7742;norank_Gnathostomata_7776;norank_Teleostomi_117570;norank_Euteleostomi_117571;superclass_Actinopterygii_7898;class_Actinopteri_186623;subclass_Neopterygii_41665;infraclass_Teleostei_32443;norank_Osteoglossocephalai_1489341;norank_Clupeocephala_186625;cohort_Euteleosteomorpha_1489388;norank_Neoteleostei_123365;norank_Eurypterygia_123366;norank_Ctenosquamata_123367;norank_Acanthomorphata_123368;norank_Euacanthomorphacea_123369;norank_Percomorphaceae_1489872;norank_Eupercaria_1489922;order_Perciformes_8111;suborder_Serranoidei_1489943;family_Serranidae_30871;subfamily_Epinephelinae_274794;tribe_Epinephelini_1505891;genus_Epinephelus_94231;species_Epinephelus bontoides_1167616

    nameline_fn = re.sub(" incertae sedis", "", nameline_fn)

    #print("nameline_fn|", nameline_fn, "|<br>")
    #exit()
    ele = nameline_fn.split(";")

    #### get recordID
    recordID_tmp = ele[0]
    recordID_tmp = re.sub(":.*", "", recordID_tmp)
    recordID_tmp = re.sub(" .*", "", recordID_tmp)
    match = re.search("^>([^\.]+\.\d+)\.", recordID_tmp)
    recordID = match.group(1)

    ##### get classification START
    classification_large = "NONE"

    if re.search("_Salmonidae_", nameline_fn):
        classification_large = "Salmonidae"
    else:
        #print("len ele", len(ele))
        #exit()
        if len(ele) > 5:   # 13
            classification_large_tmp = ele[-4]    # ele[-12]
            if re.search("_([^_]+)_", classification_large_tmp):
                match = re.search("_([^_]+)_", classification_large_tmp)
                classification_large = match.group(1)
    #classification_large_tmp = ele[-4]
    #if re.search("_([^_]+)_", classification_large_tmp):
    #    match = re.search("_([^_]+)_", classification_large_tmp)
    #    classification_large = match.group(1)
    #print("classification_large", classification_large)
    #exit()

    classification_small = "NONE"
    if re.search("_Salmoninae_", nameline_fn):
        classification_small = "Salmoninae"
    else:
        classification_small_tmp = ele[-3]
        if re.search("_([^_]+)_", classification_small_tmp):
            match = re.search("_([^_]+)_", classification_small_tmp)
            classification_small = match.group(1)
    #classification_small_tmp = ele[-3]
    #if re.search("_([^_]+)_", classification_small_tmp):
    #    match = re.search("_([^_]+)_", classification_small_tmp)
    #    classification_small = match.group(1)
    #print("classification_small", classification_small)
    #exit()

    species = "NONE"
    speciesTMP = ele[-1]

    #if re.search(" subsp_[ _]+(.*)_+\d+", speciesTMP):
    if re.search(" subsp_ .*", speciesTMP):
        #print("speciesTMP", speciesTMP, "<br>")
        #speciesTMP = re.sub(" subsp_[ _]+(.*)_+\d+", r"-\1", speciesTMP)
        speciesTMP = re.sub(" subsp_ (.*$)", r"\1", speciesTMP)
        speciesTMP = re.sub("_([^_]+)_+\d+$", r"-\1_", speciesTMP)
        #print("speciesTMP", speciesTMP, "<br>")
        #exit()
    if re.search("sedis_([^_]+)_", speciesTMP):
        match = re.search("sedis_([^_]+)_", speciesTMP)
        species = match.group(1)
        species = re.sub(" ", "-", species)
    elif re.search("species_([^_]+)_", speciesTMP):
        match = re.search("species_([^_]+)_", speciesTMP)
        species = match.group(1)
        species = re.sub(" ", "-", species)

    #print("species", species)
    ###### get classification END
    
    #revised_nameline = ">" + recordID + "_" + recordID + "_" + classification_large + "_" + classification_mediam + "_" + classification_small + "_" + species
    revised_nameline = ">" + recordID + "_" + gene_name + "_" + classification_large + "_" + classification_small + "_" + species
    revised_nameline = re.sub(" ", "", revised_nameline)
    #print("revised_nameline", revised_nameline)  # revised_nameline >AB102724.1_SRRNA_Scombrinae_Scombrini_Scomber-japonicus
    #exit()
    return revised_nameline


def delete_NGseq(dic_fasta):
    dic_fasta_fn = OrderedDict()
    for name, seq in dic_fasta.items():
        if re.search("^[A-Z]", seq):
            dic_fasta_fn[name] = seq
        else:
            print("Error. Check sequence:")
            print("name:",  name)
            print("seq:", seq)
            print()
    return dic_fasta_fn


def readFasta_dict(filename):
    seq_dict = OrderedDict()
    with open(filename, "r") as infile:
        name = None  # 変数 name を初期化
        for line in infile:
            line = line.strip()
            if not line:
                continue  # 空行をスキップ
            if line.startswith(">"):
                name = line
                seq_dict[name] = ""
            elif name:
                seq_dict[name] += line
            else:
                raise ValueError("ERROR: ヘッダーの前に配列があります。")
    return seq_dict


def changeNameLine(dic_fasta):
    #print("### changeNameLine() ###")
    seq_dict_fn = OrderedDict()
    for nameline, sequence in dic_fasta.items():
        nameline_mode = change_MIDORI_nameLine(nameline)
        seq_dict_fn[nameline_mode] = sequence
    return seq_dict_fn

############################################################################################

infileName = sys.argv[1]
outfileName = "out_" + infileName

# get genename from file name
match = re.search("_([^_]+)_RAW", infileName)
gene_name = match.group(1)

print("####################")
print("#### Start 010_MIDORI2phyloBARCODER.py for")
print("gene name:\t", gene_name)

# get fasta
dic_fasta = readFasta_dict(infileName)
#for name, seq in dic_fasta.items():
#    print("name", name)
#    print("seq", seq)
dic_fasta = delete_NGseq(dic_fasta)
dic_fasta = changeNameLine(dic_fasta)
print("Records:\t", len(dic_fasta))

###### Printout
out = open(outfileName, "w")
for name, seq in dic_fasta.items():
    out.write(f"{name}\n")
    out.write(f"{seq}\n")
out.close()

print("#### End 010_MIDORI2phyloBARCODER.py for")
print("gene name:\t", gene_name)
print("####################")

print()
exit()
